/*
 * cuba_int.cpp
 *
 *  Created on: May 3, 2014
 *      Author: daniel
 */

#include "cuba.h"
#include "cuba_int.h"
//#include "sm_control.h"
//#include "utils.h"

using CuTe::Rand;
/*using CuTe::NS_CUBA_integration::CUBACORE_GETTER;
using CuTe::Shared_Memory_Control::SM_Serial_ID;



static int CuTe::NS_CUBA_integration::CUBACORE_TEST_FUNCS::test_integrand(const int *ndim, const double xx[],const int *ncomp, double ff[], void *userdata){
	NS_Utils::DOUT dout("CUBACORE_GETTER::test_integrand");

	ff[0] = 2.;
	SM_Serial_ID* sid = (SM_Serial_ID*) userdata;

	dout()	<< sid	<<endl;
	return 0;
}

static void CuTe::NS_CUBA_integration::CUBACORE_TEST_FUNCS::test_init(void* params, int &core){
	SM_Serial_ID* sid = (SM_Serial_ID*) params;
	int SID = (*sid).get_new_SID();


	NS_Utils::DOUT dout("CUBACORE_GETTER::test_init");
	if(core==MASTER){
		dout()	<<"SID="<<SID	<<"\t"<<"core=MASTER"	<<endl;
	}else{
		dout()	<<"SID="<<SID	<<"\t"<<"core="<<core	<<endl;
	}
}*/


//static int CUBACORE_GETTER::test_integrand(const int *ndim, const double xx[],const int *ncomp, double ff[], void *userdata){
//	NS_Utils::DOUT dout("CUBACORE_GETTER::test_integrand");
//
//	ff[0] = 2.;
//	SM_Serial_ID* sid = (SM_Serial_ID*) userdata;
//
//	dout()	<< sid	<<endl;
//	return 0;
//}
//
//static void CUBACORE_GETTER::test_init(void* params, int &core){
//	SM_Serial_ID* sid = (SM_Serial_ID*) params;
//	int SID = (*sid).get_new_SID();
//
//
//	NS_Utils::DOUT dout("CUBACORE_GETTER::test_init");
//	if(core==MASTER){
//		dout()	<<"SID="<<SID	<<"\t"<<"core=MASTER"	<<endl;
//	}else{
//		dout()	<<"SID="<<SID	<<"\t"<<"core="<<core	<<endl;
//	}
//}


/*int CuTe::NS_CUBA_integration::CUBACORE_GETTER::_test_CUBACORES(int points_per_core){
	NS_Utils::DOUT dout("CUBACORE_GETTER::test_CUBACORES");


	SM_Serial_ID SID;
	cubacores(-1,points_per_core);

	cubainit((CUBA_IN_EX_FUNC)CUBACORE_TEST_FUNCS::test_init,&SID);
	int fail,neval;
	double integral[1], error[1], prob[1];
	Vegas(1,1,CUBACORE_TEST_FUNCS::test_integrand,&SID,1,0.1,0.1,0,0,0,10,1,1,10,0,NULL,NULL,&neval,&fail,integral,error,prob);

	int ncores = SID.get_counter();

	dout()	<<"Ncores="<<ncores	<<endl;


	cubacores(ncores,points_per_core);
	return ncores;
}


void CuTe::NS_CUBA_integration::CUBACORE_GETTER::set_ncores(int ncores,int points_per_core){
	cubacores(ncores,points_per_core);
}*/

const int CuTe::NS_CUBA_integration::Cuba_Params::cuba_uninitialized	= 0x61627563;	//	Cuba/src/common/stddecl.h:	uninitialized

void CuTe::NS_CUBA_integration::Cuba_Params::_set_ncores(const int ncores,const int points_per_core)const{
	if(ncores>=0)	cubacores(ncores,points_per_core);
	else			cubacores(cuba_uninitialized,points_per_core);
}

int CuTe::NS_CUBA_integration::Cuba_Params::_cube(vector<double> &out_results,vector<double> &out_errors,vector<double> &out_probs){
	out_results.resize(ncomp);
	out_errors.resize(ncomp);
	out_probs.resize(ncomp);

	double *_integral	= &(out_results[0]);
	double *_error		= &(out_errors[0]);
	double *_prob		= &(out_probs[0]);

	cubainit((CUBA_IN_EX_FUNC)initfunc,userdata);
	cubaexit((CUBA_IN_EX_FUNC)exitfunc,userdata);

//	double t = -get_wall_time();
	switch (routine) {
		case CUBA_R_VEGAS:
			Vegas(	ndim,ncomp
					,integrand,userdata,nvec
					,epsrel,epsabs
					,flags,seed
					,mineval,maxeval
					,nstart,nincrease,nbatch
					,gridno,statefile,NULL
					,&neval,&fail
					,_integral,_error,_prob
					);
			break;
		case CUBA_R_SUAVE:
			Suave(	ndim,ncomp
					,integrand,userdata,nvec
					,epsrel,epsabs
					,flags,seed
					,mineval,maxeval
					,nnew,nmin
					,flatness
					,statefile,NULL,&nregions
					,&neval,&fail
					,_integral,_error,_prob);
			break;
		case CUBA_R_DIVONNE:
			Divonne(ndim,ncomp
					,integrand,userdata,nvec
					,epsrel,epsabs
					,flags,seed
					,mineval,maxeval
					,key1,key2,key3,maxpass,border,maxchisq,mindeviation,NGIVEN,LDXGIVEN,NULL,NEXTRA,NULL
					,statefile,NULL,&nregions
					,&neval,&fail
					,_integral,_error,_prob);
			break;
		case CUBA_R_CUHRE:
			Cuhre(	ndim,ncomp
					,integrand,userdata,nvec
					,epsrel,epsabs
					,flags
					,mineval,maxeval
					,key
					,statefile,NULL,&nregions
					,&neval,&fail
					,_integral,_error,_prob);
		default:
			break;
	}
//	cout << "Integration time = " << t+get_wall_time() << endl;
//	out_results.
//	out_results = vector<double>(_integral,_integral + ncomp);
//	out_errors = vector<double>(_error,_error + ncomp);
//	out_probs = vector<double>(_prob,_prob + ncomp);

//	for(int i=0; i<ncomp; ++i){
//		cout	<< "F["<<i<<"] = " << integral[i]
//		    	<< " +- " << error[i]
//				<< "\t p = " << prob[i]
//		    	<< "\t n = " << neval;
		if(fail!=0 && fail!=1) std::cerr << "\t fail = " << fail	<< endl;
//		else  cout << "\t fail = " << fail	<< endl;
//	}
	if(fail!=0){
		if(fail==-1) std::cerr<<"Cuba"<<routine<<" dim="<<ndim<<" out of range"<<endl;
		if(fail== 1) std::cerr<<"Cuba"<<routine<<" accuracy goal not reached"<<endl;
		if(fail > 1) std::cerr<<"Cuba"<<routine<<" accuracy goal not reached, increase maxeval by:"<<fail<<endl;
	}

	return fail;
}


int CuTe::NS_CUBA_integration::Cuba_Params::_test(int n,vector<double> &out_results,vector<double> &out_errors,vector<double> &out_probs){
	NS_Utils::DOUT dout("Cuba_Params::_test","n");
	dout()	<<"ndim ="<<ndim	<<"\t"<<"ncomp="<<ncomp	<<"\t"<<"n="<<n<<endl;

	out_results.assign(ncomp,0.);
	out_errors.assign(ncomp,42);
	out_probs.assign(ncomp,24);

//	using NS_Utils::operator <<;
//	dout()	<<"out_results("<<out_results.size()<<"):"<<endl;
//	dout()	<<out_results<<endl;
//	dout()	<<"out_errors("<<out_errors.size()<<"):"<<endl;
//	dout()	<<out_errors<<endl;
//	dout()	<<"out_probs("<<out_probs.size()<<"):"<<endl;
//	dout()	<<out_probs<<endl;

	double *_integral	= &(out_results[0]);
	double *_error		= &(out_errors[0]);
	double *_prob		= &(out_probs[0]);

	double ff[ncomp];
	double xx[ndim];

	Rand rand(seed);

	int core =0;

	if(initfunc) initfunc(userdata,core);
	timer.start();
	for(int i=0; i<n; ++i){
//		std::stringstream tmp;
//		tmp<<"i="<<i<<" < "<<n;
//		NS_Utils::DOUT dout(tmp.str());
		for(int d=0; d<ndim; ++d){
			xx[d] = rand();
//			dout()<<"\txx["<<d<<"]="<<xx[d]<<endl;
		}

		integrand(&ndim, xx, &ncomp, ff, userdata);

		for(int j=0; j<ncomp; ++j)	_integral[j]	+= ff[j];
//		dout()	<<"out_results("<<out_results.size()<<"):"<<endl;
//		dout()	<<out_results<<endl;
	}
	for(int j=0; j<ncomp; ++j)	_integral[j]	/=n;
	if(exitfunc) exitfunc(userdata,core);

	using CuTe::NS_Utils::operator <<;
	dout() << "Integration time = " << timer.stop() << endl;
//	out_results	= vector<double>(_integral,_integral + ncomp);
//	out_errors	= vector<double>(ncomp,42);
//	out_probs	= vector<double>(ncomp,24);

	for(int j=0; j<ncomp; ++j){
		dout()	<< "F["<<j<<"] = " << out_results[j] << endl;
	}

	return fail;
}



int CuTe::NS_CUBA_integration::Cuba_Params::_test_vegas(int n,vector<double> &out_results,vector<double> &out_errors,vector<double> &out_probs){
	out_results.assign(ncomp,0.);
	out_errors.assign(ncomp,42);
	out_probs.assign(ncomp,24);

	double *_integral	= &(out_results[0]);
	double *_error		= &(out_errors[0]);
	double *_prob		= &(out_probs[0]);

	double ff[ncomp];
	double xx[ndim];

	cuba_integrand_t_vegas integrand = (cuba_integrand_t_vegas) this->integrand;

	Rand rand(seed);

	double weight=1.;
	int iter=1;

	int core =0;

	if(initfunc) initfunc(userdata,core);
	timer.start();
	for(int i=0; i<n; ++i){
		for(int d=0; d<ndim; ++d)	xx[d] = rand();

		integrand(&ndim, xx, &ncomp, ff, userdata,&nvec,&weight,&iter);

		for(int j=0; j<ncomp; ++j)	_integral[j]	+= ff[j];
	}
	for(int j=0; j<ncomp; ++j)	_integral[j]	/=n;
	if(exitfunc) exitfunc(userdata,core);

	using CuTe::NS_Utils::operator <<;
	cout << "Integration time = " << timer.stop() << endl;
//	out_results	= vector<double>(_integral,_integral + ncomp);
//	out_errors	= vector<double>(ncomp,0.);
//	out_probs	= vector<double>(ncomp,0.);

	for(int j=0; j<ncomp; ++j){
		cout	<< "F["<<j<<"] = " << integral[j] << endl;
	}

	return fail;
}


